let implode cl = String.concat "" (List.map (String.make 1) cl)

module type ARRAY =
  sig
    type 'a t
    val fromList : 'a list -> 'a t
    val fromInt : int -> bool t
    val get : int -> 'a t -> 'a
  end

module Array1 : ARRAY =
  struct
    type 'a t = 'a list
    let fromList xs = xs
    let fromInt x = List.init 32 (fun i -> ((x lsr i) land 1) = 1)
    let get i a = List.nth a i
  end

module Array2 = 
  struct
    type 'a t = 
      | List of 'a list
      | Int of int

    let fromList x = List x
    let fromInt x = Int x
  
    let get i = function
      | List xs -> List.nth xs i
      | Int x -> ((x lsr i) land 1) = 1
  end

(* type 'a option =
  | None 
  | Some of 'a

type 'a list = 
  | Nil
  | Cons of 'a * 'a list

type 'a option =
  | None : 'a option
  | Some : 'a -> 'a option

type 'a list =
  | Nil : 'a list
  | Cons : 'a * 'a list -> 'a list *)


module Array3 : ARRAY = 
  struct
    type 'a t = 
      | List : 'a list -> 'a t
      | Int : int -> bool t

    let fromList x = List x
    let fromInt x = Int x
  
    let get : type a. int -> a t -> a = fun i -> function
      | List xs -> List.nth xs i
      | Int x -> ((x lsr i) land 1) = 1

    let toString : char t -> string = function
      | List xs -> implode xs

  end


let head : 'a list -> 'a = function
  | [] -> failwith "whoops!"
  | x::xs -> x

let rec zip : 'a list * 'b list -> ('a * 'b) list = function
  | [],[] -> []
  | x::xs,y::ys -> (x,y) :: zip (xs,ys)
  | _ -> failwith "whoops!"

(* 

type ('a,'len) vec =
  | Nil : ('a,0) vec
  | Cons : 'a * ('a,'n) vec -> ('a,'n + 1) vec

 *)


type z = Junk
type 'a s = Junk

type ('a,'len) vec =
  | Nil : ('a,z) vec
  | Cons : 'a * ('a,'n) vec -> ('a,'n s) vec

let head : type a n. (a,n s) vec -> a = function
  | Cons (x,_) -> x

let rec zip : type a b n. (a,n) vec * (b,n) vec -> (a * b,n) vec = function
  | Nil,Nil -> Nil
  | Cons(x,xs),Cons(y,ys) -> Cons((x,y) ,zip (xs,ys))

(* let rec append : type a m n. (a,n) vec -> (a,m) vec -> (a,n + m) vec ??? *)

(* let rec filter : type a n. (a -> bool) -> (a,n) vec -> (a,???) vec *)

(* 

  All nodes are either red or black
  The empty tree is black
  All leaves are black
  Red nodes have black children
  Any path from a node to one of its descendant leaves 
    has the same number of black nodes
 *)

type black = Junk
type red = Junk

type ('a,'color,'n) tree = 
  | Empty : ('a,black,z) tree
  | Red : ('a,black,'n) tree * ('a,black,'n) tree * 'a -> ('a,red,'n) tree
  | Black : ('a,'c1,'n) tree * ('a,'c2,'n) tree * 'a -> ('a,black,'n s) tree